import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class EditDialog extends Dialog implements java.awt.event.ActionListener, java.awt.event.KeyListener , java.awt.event.WindowListener {

	private LavaLayout mainLayout=null; 

    private TextField fieldInput = null;
    private Label labelInput = null;
    private Button buttonDelete = null;
    private Button buttonUndelete = null;
    private Button buttonOk = null;
    private Button buttonCancel = null;
    private Button buttonEditCol = null;
    private Button buttonEditEntireRecord = null;
    private Button buttonNA = null;

	private CalendarPanel CalPanel=null;

	private String thedate="";
	private String mon="";
	private String day="";
	private String year="";

	private TextArea ta1=null;

	private Jbrowse thisapplet=null;

	public EditDialog(Frame parent, String title, String valueline, String oldval, TextArea ta, Jbrowse applet) {

		super(parent, title, true);

		Toolkit tk = parent.getToolkit(); 
		Rectangle r = parent.getBounds();

		setBackground( new Color( 192, 192, 192 ) );
		setForeground( new Color( 0, 0, 0 ) );

		Dimension screensize = tk.getScreenSize();
			//int adjwidth = new Double(screensize.width*.94).intValue();
			//int adjheight = new Double(screensize.height*.94).intValue();
		int adjwidth = 500;
		int adjheight = 400;

		this.setBounds(new Rectangle((screensize.width-adjwidth)/2, (screensize.height-adjheight)/2, adjwidth, adjheight));
		setResizable( true );

		addWindowListener( this );

		makeGUI();

		thisapplet = applet;
		thisapplet.editrowflag=false;
		thisapplet.editcolflag=false;

		ta1=ta;

		if(thisapplet.valuetype[thisapplet.col].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {

			CalPanel = new CalendarPanel("Date");
			mainLayout.setConstraints( CalPanel, makeLavaCons( 10, 10, 30, 30 ) );
			String year = oldval.substring(0,4);
			String mon = oldval.substring(4,6);
			String day = oldval.substring(6,8);
			String thedate = mon+"/"+day+"/"+year; 
			CalPanel.setDateString(thedate);
			thedate=oldval;

			CalPanel.addActionListener(this);
			CalPanel.dropit(true);
			CalPanel.setAttachToTop(false);
			CalPanel.setRefreshParent(true, (java.awt.Container) this);

			this.add(CalPanel);

			fieldInput.setVisible(false);
			labelInput.setVisible(false);
			buttonDelete.setVisible(false);
			buttonUndelete.setVisible(false);
			buttonOk.setVisible(false);
			buttonCancel.setVisible(false);
			buttonEditCol.setVisible(false);
			buttonEditEntireRecord.setVisible(false);
			buttonNA.setVisible(false);
		}
		else { 
			fieldInput.setText(oldval.trim());

			fieldInput.setVisible(true);
			labelInput.setVisible(true);
			buttonDelete.setVisible(true);
			buttonUndelete.setVisible(true);
			buttonOk.setVisible(true);
			buttonCancel.setVisible(true);
			buttonEditCol.setVisible(true);
			buttonEditEntireRecord.setVisible(true);
			buttonNA.setVisible(true);
		}
		initlisteners();
	

	}
	public void initlisteners() {
		buttonEditEntireRecord.addActionListener(this);
		buttonEditCol.addActionListener(this);
		buttonUndelete.addActionListener(this);
		buttonDelete.addActionListener(this);
		buttonCancel.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonNA.addActionListener(this);
		fieldInput.addKeyListener(this);		
	}

	public void keyTyped(java.awt.event.KeyEvent e) {
	}
	public void keyReleased(java.awt.event.KeyEvent e) {
		if((e.getSource() == fieldInput) ) {
			if(e.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
				if(thisapplet.valuetype[thisapplet.col].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) { 
					thisapplet.newval="";
					Date editdate = CalPanel.getDate();
					mon = new Integer(editdate.getMonth()+1).toString();
					day = new Integer(editdate.getDate()).toString();
					year = new Integer(editdate.getYear()+1900).toString();
					if(mon.length()==1) mon = "0".concat(mon);
					if(day.length()==1) day = "0".concat(day);
					thedate = year+mon+day;
					thisapplet.updateDate(thedate);
				}
				else thisapplet.newval = fieldInput.getText().trim();

				if(thisapplet.newval.equals(".")) thisapplet.newval="";
				dispose();
			}
			if(e.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
				thisapplet.newval = ""; 
				dispose();
			}
		}
	}

	public void keyPressed(java.awt.event.KeyEvent e) {
	}


	public void actionPerformed(java.awt.event.ActionEvent e) {

		if(e.getSource()==CalPanel) {
			thisapplet.newval="";
			Date editdate = CalPanel.getDate();
			mon = new Integer(editdate.getMonth()+1).toString();
			day = new Integer(editdate.getDate()).toString();
			year = new Integer(editdate.getYear()+1900).toString();
			if(mon.length()==1) mon = "0".concat(mon);
			if(day.length()==1) day = "0".concat(day);
			String tdate = year+mon+day;
			thisapplet.updateDate(tdate);
			dispose();
		}


		if(e.getSource() == buttonEditEntireRecord) {
			thisapplet.editrowflag=true;
			dispose();
		}
		if(e.getSource() == buttonEditCol) {
			thisapplet.editcolflag=true;
			dispose();
		}
		
		if(e.getSource() == buttonUndelete) {
			thisapplet.newval = "undeletethisrecord123";
			dispose();
		}
		
		if(e.getSource() == buttonDelete) {
			thisapplet.newval = "deletethisrecord123";
			dispose();
		}
		
		if(e.getSource() == buttonCancel) {
			thisapplet.newval = "";
			dispose();
		}
		
		if(e.getSource() == buttonOk) {
			if(thisapplet.valuetype[thisapplet.col].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true)  {
				thisapplet.newval="";
				Date editdate = CalPanel.getDate();
				mon = new Integer(editdate.getMonth()+1).toString();
				day = new Integer(editdate.getDate()).toString();
				year = new Integer(editdate.getYear()+1900).toString();
				if(mon.length()==1) mon = "0".concat(mon);
				if(day.length()==1) day = "0".concat(day);
				thedate = year+mon+day;
				thisapplet.updateDate(thedate);
			}
			else thisapplet.newval = fieldInput.getText().trim();

			if(thisapplet.newval.equals(".")) thisapplet.newval="";
			dispose();
		}
		if(e.getSource() == buttonNA) {
			thisapplet.newval = "NA"; 
			dispose();
		}

	}





    private void makeGUI()
    {

        mainLayout = new LavaLayout( 30, 40 );
        setLayout( mainLayout );
        fieldInput = new TextField( "", 20 );
        mainLayout.setConstraints( fieldInput, makeLavaCons( 5, 5, 21, 3 ) );
        add( fieldInput );
        fieldInput.setBackground( new Color( 192, 192, 192 ) );
        fieldInput.setForeground( new Color( 0, 0, 0 ) );
        fieldInput.setEnabled( true );
        fieldInput.setVisible( true );
        buttonDelete = new Button( "DELETE" );
        mainLayout.setConstraints( buttonDelete, makeLavaCons( 6, 13, 19, 3 ) );
        add( buttonDelete );
        buttonDelete.setBackground( new Color( 192, 192, 192 ) );
        buttonDelete.setForeground( new Color( 0, 0, 0 ) );
        buttonDelete.setEnabled( true );
        buttonDelete.setVisible( true );
        buttonUndelete = new Button( "UNDELETE" );
        mainLayout.setConstraints( buttonUndelete, makeLavaCons( 6, 17, 19, 3 ) );
        add( buttonUndelete );
        buttonUndelete.setBackground( new Color( 192, 192, 192 ) );
        buttonUndelete.setForeground( new Color( 0, 0, 0 ) );
        buttonUndelete.setEnabled( true );
        buttonUndelete.setVisible( true );
        buttonOk = new Button( "OK" );
        mainLayout.setConstraints( buttonOk, makeLavaCons( 6, 33, 19, 3 ) );
        add( buttonOk );
        buttonOk.setBackground( new Color( 192, 192, 192 ) );
        buttonOk.setForeground( new Color( 0, 0, 0 ) );
        buttonOk.setEnabled( true );
        buttonOk.setVisible( true );
        buttonCancel = new Button( "CANCEL" );
        mainLayout.setConstraints( buttonCancel, makeLavaCons( 6, 29, 19, 3 ) );
        add( buttonCancel );
        buttonCancel.setBackground( new Color( 192, 192, 192 ) );
        buttonCancel.setForeground( new Color( 0, 0, 0 ) );
        buttonCancel.setEnabled( true );
        buttonCancel.setVisible( true );
        labelInput = new Label( "Enter Value and Press Enter", Label.CENTER );
	labelInput.setFont(new Font("Monospaced", 1, 11));
        mainLayout.setConstraints( labelInput, makeLavaCons( 8, 3, 15, 2 ) );
        add( labelInput );
        labelInput.setBackground( new Color( 192, 192, 192 ) );
        labelInput.setForeground( new Color( 0, 0, 0 ) );
        labelInput.setEnabled( true );
        labelInput.setVisible( true );
        buttonEditCol = new Button( "EDIT COLUMN" );
        mainLayout.setConstraints( buttonEditCol, makeLavaCons( 6, 21, 19, 3 ) );
        add( buttonEditCol );
        buttonEditCol.setBackground( new Color( 192, 192, 192 ) );
        buttonEditCol.setForeground( new Color( 0, 0, 0 ) );
        buttonEditCol.setEnabled( true );
        buttonEditCol.setVisible( true );
        buttonEditEntireRecord = new Button( "EDIT ENTIRE RECORD" );
        mainLayout.setConstraints( buttonEditEntireRecord, makeLavaCons( 6, 25, 19, 3 ) );
        add( buttonEditEntireRecord );
        buttonEditEntireRecord.setBackground( new Color( 192, 192, 192 ) );
        buttonEditEntireRecord.setForeground( new Color( 0, 0, 0 ) );
        buttonEditEntireRecord.setEnabled( true );
        buttonEditEntireRecord.setVisible( true );
        buttonNA = new Button( "FILL WITH NA" );
        mainLayout.setConstraints( buttonNA, makeLavaCons( 6, 9, 19, 3 ) );
        add( buttonNA );
        buttonNA.setBackground( new Color( 192, 192, 192 ) );
        buttonNA.setForeground( new Color( 0, 0, 0 ) );
        buttonNA.setEnabled( true );
        buttonNA.setVisible( true );

    }

    public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
    {

        GridBagConstraints cons = new GridBagConstraints();

        cons.weightx    = wx;
        cons.weighty    = wy;
        cons.gridx      = x;
        cons.gridy      = y;
        cons.gridwidth  = dx;
        cons.gridheight = dy;
        cons.fill       = fill;
        cons.anchor     = anch;
        cons.insets     = new Insets( it, il, ib, ir );
        cons.ipadx      = px;
        cons.ipady      = py;

        return cons;

    }

    public LavaLayoutConstraints makeLavaCons( int x, int y, int dx, int dy )
    {

        LavaLayoutConstraints cons = new LavaLayoutConstraints();

        cons.gridX      = x;
        cons.gridY      = y;
        cons.gridWidth  = dx;
        cons.gridHeight = dy;

        return cons;

    }

    public void windowClosing( WindowEvent event ) { dispose(); }
    public void windowOpened( WindowEvent event ) {}
    public void windowIconified( WindowEvent event ) {}
    public void windowDeiconified( WindowEvent event ) {}
    public void windowClosed( WindowEvent event ) {}
    public void windowActivated( WindowEvent event ) {}
    public void windowDeactivated( WindowEvent event ) {}

}





