
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.text.*;
import java.lang.Math.*;

import xBaseJ.*;

import IniFileIO;
import BorderPanel;

public class Jbrowse extends Applet implements java.awt.event.ActionListener, java.awt.event.KeyListener ,java.awt.event.MouseListener {


	private String version = "Jbrowse version 1.16.43";

	public CloseableFrame	superframe=null;
	public Toolkit	tk=null;	
	public  boolean   appletflg=true;

	public int conncount=0;
	public int totalbytes=0;
	public int inuse=0;

	public boolean showxbaseversion=false;


	private IniFileIO inifile=null;
	private IniFileIO helpfile=null;

	HelpDialog hd = null;

	public JbrowsePanel jp=null;

	//ini file stuff
	public boolean alwayseditentirerecord=false;
	public boolean readonly=true;
	public boolean readgoto=true;
	public boolean loopadd=true;
	public boolean loopedit=true;
	public boolean showtype =false;
	public boolean usedatepicker=true;
	public String  startdirectory="";
	public String  filemask="*.dbf";
	public int     inireclines=0;
	public int fontsize=8;
	public int entryfontsize=8;
	public int maxfieldwidthcol=40;
	public int extracharsperrow=0;
	public int screenx=500;
	public int screeny=400;


	//stuff I need to sort through
	public int recposition=1;
	public int reclines=45;
	private int nrecords=0;
	public String inifilename="jbrowse.ini";
	public boolean indexexists=false;
	private xBaseJ.DBF adbf=null;
	private xBaseJ.Field f=null;
	private StringBuffer textabuild = null; 
	public String filename="";
	public int[] fca = null; 
	public int[] flen = null; 
	public String[] fname = null; 
	public int nf=0;
	public int caret=1;
	private int recordlinelen = 0;
	public int row=0, col=0;
	public String newval="";
	public String fieldtitle="";
	public String[] addvalues=null;
	public String[] valuetype=null;
	public String[] colvalues=null;
	public boolean cancelflag=false;
	public boolean editrowflag=false;
	public boolean editcolflag=false;
	public int recordlinelenadj=0;



public static void main(java.lang.String[] args) {
	try {
		Jbrowse aJbrowse = new Jbrowse();
		try {
			aJbrowse.inifilename = args[0];
		} catch(Exception e) { }
		aJbrowse.init();
		aJbrowse.start();
		aJbrowse.appletflg=false;
		

	} catch (Throwable exception) {
		System.err.println("main"+exception.toString());
	}
}

//INIT CODE

public void init() {
		this.setSize(this.getMinimumSize());

	try { 
		inifile = new IniFileIO(inifilename, "rw");		
		inifile.open();
		int numberoflines=inifile.numberoflines;

		if(numberoflines >0) {
			boolean bval;
			String  sval="";
			String inival="";
				
			bval=alwayseditentirerecord;
			inival = inifile.getVar("alwayseditentirerecord");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				alwayseditentirerecord=bval;
			}

			bval=readonly;
			inival = inifile.getVar("readonly");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				readonly=bval;
			}

			bval=readgoto;
			inival = inifile.getVar("readgoto");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				readgoto=bval;
			}

			bval=loopadd;
			inival = inifile.getVar("loopadd");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				loopadd=bval;
			}

			bval=loopedit;
			inival = inifile.getVar("loopedit");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				loopedit=bval;
			}


			bval=usedatepicker;
			inival = inifile.getVar("usedatepicker");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				usedatepicker=bval;
			}

			bval=showtype;
			inival = inifile.getVar("showtype");
			if(inival!=null) {
				if(inival.toUpperCase().trim().equals("TRUE")) bval=true;
				if(inival.toUpperCase().trim().equals("FALSE")) bval=false;
				showtype=bval;
			}

			inival = inifile.getVar("startdirectory");
			if(inival!=null) {
				if(inival.length() > 0) startdirectory=inival;
			}

			inival = inifile.getVar("filemask");
			if(inival!=null) {
				if(inival.length() > 0) filemask=inival;
			}

			inival = inifile.getVar("recordlines");
			if(inival!=null) {
				if(inival.length() > 0) inireclines=new Integer(inival).intValue();
				reclines=inireclines;
			}

			inival = inifile.getVar("extracharsperrow");
			if(inival!=null) {
				if(inival.length() > 0) extracharsperrow=new Integer(inival).intValue();
			}

			inival = inifile.getVar("fontsize");
			if(inival!=null) {
				if(inival.length() > 0) fontsize=new Integer(inival).intValue();
			}

			inival = inifile.getVar("entryfontsize");
			if(inival!=null) {
				if(inival.length() > 0) entryfontsize=new Integer(inival).intValue();
			}

			inival = inifile.getVar("maxfieldwidthcol");
			if(inival!=null) {
				if(inival.length() > 0) maxfieldwidthcol=new Integer(inival).intValue();
			}

			inival = inifile.getVar("screenx");
			if(inival!=null) {
				if(inival.length() > 0) screenx=new Integer(inival).intValue();
			}
			inival = inifile.getVar("screeny");
			if(inival!=null) {
				if(inival.length() > 0) screeny=new Integer(inival).intValue();
			}
		}


		


		superframe = new CloseableFrame();
		superframe.setLayout(new BorderLayout());	
		superframe.setBackground(new Color(255,255,255));

		//add a panel.
		jp = new JbrowsePanel();

		//add Listeners
		jp.buttonOpen.addActionListener(this);
		jp.buttonExit.addActionListener(this);
		jp.buttonTop.addActionListener(this);
		jp.buttonBottom.addActionListener(this);
		jp.buttonUP.addActionListener(this);
		jp.buttonDOWN.addActionListener(this);
		jp.buttonPack.addActionListener(this);
		jp.buttonCreateIndex.addActionListener(this);
		jp.buttonFind.addActionListener(this);
		jp.buttonGoto.addActionListener(this);
		jp.buttonConfig.addActionListener(this);
		jp.buttonAdd.addActionListener(this);
		jp.Help.addActionListener(this);

		jp.TextArea.addMouseListener(this);
		jp.TextArea.setFont(new java.awt.Font("Monospaced", 0, fontsize));

		tk = superframe.getToolkit(); 
		Dimension screensize = tk.getScreenSize();
			//int adjwidth = new Double(screensize.width*.94).intValue();
			//int adjheight = new Double(screensize.height*.94).intValue();
		int adjwidth = screenx;
		int adjheight = screeny;

		superframe.setBounds(new Rectangle((screensize.width-adjwidth)/2, (screensize.height-adjheight)/2, adjwidth, adjheight));
		superframe.add("Center", jp);
		superframe.setTitle(version);


		helpfile = new IniFileIO("Jbrowse.hlp", "r");		
		helpfile.open();

		hd = new HelpDialog(superframe, "Jbrowse", this);
		hd.getHelpArea().setText("\n\n"+version+"\n");
		hd.getHelpArea().setFont(new java.awt.Font("Monospaced", 0, 12));

		for(int cnt=0; cnt<helpfile.numberoflines; cnt++) {
			String line = helpfile.getLine(cnt);
			hd.getHelpArea().append(line+"\n");
		}

	} catch(Exception e) { handleError(e.toString()); }


}

public void start() {
		superframe.setVisible(true);
}


//UTIL

public class WindowCloser extends WindowAdapter {
	public void windowClosing(WindowEvent e) {
		System.exit(0);
	}
		
}
public class CloseableFrame extends Frame {
public WindowCloser wc=null;

	public CloseableFrame() {
		wc = new WindowCloser();
		addWindowListener(wc);
	}
}

//EVENT CODE

//haven't finished config yet
//jp.buttonConfig.addActionListener(this);

public void actionPerformed(java.awt.event.ActionEvent e) {
	if(e.getSource()==jp.buttonExit) {
		try {
			Rectangle r = superframe.getBounds();
			screenx = r.width; 
			screeny = r.height; 
			inifile.updateVar("screenx", new Integer(this.screenx).toString());
			inifile.updateVar("screeny", new Integer(this.screeny).toString());
			inifile.flushChanges();
			inifile.close(); 
		} catch(Exception inie) { handleError(inie.toString()+"save screen size"); }
		superframe.wc.windowClosing(new WindowEvent(superframe, java.awt.event.WindowEvent.WINDOW_CLOSING));
	}

	if(e.getSource()==jp.buttonOpen) {
		openDbase();
	}
	if(e.getSource()==jp.buttonUP) {
		goUp();
	}
	if(e.getSource()==jp.buttonDOWN) {
		goDown();
	}
	if(e.getSource()==jp.buttonGoto) {
		gotoRecord();
	}
	if(e.getSource()==jp.buttonFind) {
		findRecords();
	}
	if(e.getSource()==jp.buttonTop) {
		gotoTop();
	}
	if(e.getSource()==jp.buttonBottom) {
		gotoBott();
	}
	if(e.getSource()==jp.buttonPack) {
		recordPack();
	}
	if(e.getSource()==jp.buttonCreateIndex) {
		indexCreate();
	}
	if(e.getSource()==jp.buttonAdd) {
		addRecords();
	}

	if(e.getSource()==jp.Help) {
		hd.show();
	}
}
public void keyTyped(java.awt.event.KeyEvent e) {
}
public void keyReleased(java.awt.event.KeyEvent e) {
}
public void keyPressed(java.awt.event.KeyEvent e) {
}

public void mousePressed(java.awt.event.MouseEvent e) {
}
public void mouseReleased(java.awt.event.MouseEvent e) {
	if (e.getSource() == jp.TextArea ) {

		if(jp.TextArea.getSelectedText().length() > 0) {
			int startpos = jp.TextArea.getCaretPosition(); 
			int linelen=0;
			linelen=recordlinelen+1+extracharsperrow;

			row = (startpos/linelen);	
			col = startpos-(linelen*row);	

			col++;
			int t1=0;
			int fw=0;
			int fn=0;

			for(fn=1; fn<=nf; fn++) {
				t1+=fca[fn];
				if(t1 >= col ) {
					col=fn;
					fw =fca[fn];
					break;
				} 
			}
			
			t1-=fca[fn];

			String tastring = jp.TextArea.getText();
			StringTokenizer st = new StringTokenizer(tastring, "\n");
			int not = st.countTokens();
			String[] sbuff = new String[not-1];
			if(not > 1) {
				String ft = st.nextToken();
				fieldtitle = ft.substring(t1,t1+fw);
				for(int cnt=0; cnt<not-1; cnt++) {
					sbuff[cnt] = st.nextToken();	
				}
			}

			if(row==0) return;
			String oldval = sbuff[row-1].substring(t1,t1+fw);

			if(!alwayseditentirerecord) getEditValue(oldval, newval);	
				else {editrowflag=true;}
			
			if(editcolflag==true) {
				readRecordsCol(filename, col);
				EditColDialog ecd = new EditColDialog(superframe, "Edit "+fieldtitle+" Records", this);
				ecd.show();
				ecd=null;
				if(!cancelflag) { 
					updateColumn(filename, col);
				}
			}

			else if(editrowflag==true) {
				int record=row+recposition;

				readRecordsRow(filename, record);
				EditRowDialog erd = new EditRowDialog(superframe, "Edit Record", this);
				erd.show();

			}
			else if(newval.equals("deletethisrecord123")) {
				deleteRecords(filename, row+recposition);
			}
			else if(newval.equals("undeletethisrecord123")) {
				undeleteRecords(filename, row+recposition);
			}
			else if(newval.length()>0) {
				if(newval.length() > flen[col]) newval = newval.substring(0,flen[col]);
				writeRecord(filename, row+recposition, col, newval);
			}
			readRecords(filename, "");
			jp.TextArea.setSelectionEnd(jp.TextArea.getCaretPosition());
			jp.TextArea.setSelectionStart(jp.TextArea.getCaretPosition());
		}
	}
}
public void mouseClicked(java.awt.event.MouseEvent e) {
}
public void mouseMoved(java.awt.event.MouseEvent e) {
}
public void mouseEntered(java.awt.event.MouseEvent e) {
}
public void mouseExited(java.awt.event.MouseEvent e) {
}




/**************************** OPEN FILE *********************************/

public void openDbase() {

try {
	FileDialog fd = new FileDialog(superframe, "Select Dbase file to browse/edit", java.awt.FileDialog.LOAD);
	fd.setFile(filemask);
	if(startdirectory.length()>0) fd.setDirectory(startdirectory);
	fd.setModal(true);
	fd.show();

	
	if(fd.getFile()!=null) {
		filename = fd.getDirectory()+fd.getFile().substring(0,fd.getFile().indexOf("."));
		nrecords=0; 
		reclines = inireclines;
		row=0; col=0; String newval="";
		jp.TextArea.setCaretPosition(1);

		jp.TextArea.setSelectionStart(1);
		jp.TextArea.setSelectionEnd(1);

			recposition=1;
			readRecords(filename, "");
	}
	else filename="";
}
catch(Exception e) { handleError(e.toString()+"->open dbase file"); }
}



/*************************** READ RECORDS INTO BUFFER ********************/

public void readRecordsRow(String dbname, int record) {
	record--;
	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) { handleError(e.toString()); }

	try {
		indexexists=true;
		adbf.useIndex(filename+".ndx");
	} catch(Exception e) {  indexexists=false; } 

	   try {
		if(record>0) adbf.gotoRecord(record);

		addvalues = new String[adbf.fldcount()*2];
		valuetype = new String[adbf.fldcount()*2];

		 for (int j = 1; j <= adbf.fldcount(); j++) {
				f = adbf.getField(j); 
				addvalues[j] = f.get().trim();				
				valuetype[j] = new Character(f.type()).toString();
		 }
	   } catch(Exception e) { handleError(e.toString()); }

	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }

	return;
}

public void readRecordsCol(String dbname, int column) {
	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) { handleError(e.toString()); }

	try {
		indexexists=true;
		adbf.useIndex(filename+".ndx");
	} catch(Exception e) {  indexexists=false; } 


	nf=adbf.fldcount();
	fca = new int[nf*2];
	flen = new int[nf*2];
	fname = new String[nf*2];
	valuetype = new String[nf*2];

	for(int cnt=0; cnt<nf*2; cnt++) {
		fca[cnt]=0;
		flen[cnt]=0;
		fname[cnt]="";
		valuetype[cnt]="";
	}

	textabuild = new StringBuffer(1024*reclines);
	int i=0;
	recordlinelen=0;

	colvalues = new String[reclines+2];

	int colindex=1;



	for (i = recposition; i < recposition+reclines; i++)
	{
		  try { 
			 if(i>0) adbf.gotoRecord(i);
		  } catch(Exception e) { handleError(e.toString()+" goto record:"); }

		String fg = "";
		int j=1;


	   try {
			  f =  adbf.getField(column);

		valuetype[j] = new Character(f.type()).toString();

		if(f.name().length() > f.length()) fca[j]=f.name().length()+1;
			else fca[j]=f.length()+1;
		flen[j] = f.length();

		fname[j]=f.name();

		fg=padstring(f.name(), fca[j]);

	   } catch(Exception e) { handleError(e.toString()); }


		recordlinelen+=fca[j];
		textabuild.append(fg);

		if(f.get().trim().length()==0) fg=padstring(".", fca[j]);
			else fg=padstring(f.get(), fca[j]);

		if(adbf.deleted()==true) fg=padstring("*", fca[j], "*");


		colvalues[colindex++] = fg.trim(); 
	}

	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }

	return;
}


public void readRecords(String dbname, String findkey) {

	caret = jp.TextArea.getCaretPosition();
	String keyfields="";
	jp.TextArea.setText("");


	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) {  handleError(e.toString() + ">new dbase"); } 

	if(!showxbaseversion) {
		showxbaseversion=true;
		ErrorDialog ed = new ErrorDialog(superframe, "Xbase Version", "Using xbase version: "+adbf.version(), this);
		ed.setModal(false);
		ed.show();
	}

	try {
		indexexists=true;
		Index ndx = adbf.useIndex(filename+".ndx");
		keyfields = ndx.getKeyFields();

	} catch(Exception e) {  indexexists=false; } 

	if(findkey.length()>0) { 
		try {
			adbf.find(findkey.trim()); 
			recposition=adbf.recno();
		} catch(Exception e) { handleError(e.toString()+"<-findkey"); }
	}

	reclines=inireclines;
	nrecords = adbf.reccount();
	if(nrecords < reclines) { reclines=nrecords; recposition=1; }

	if(nrecords <= (recposition+reclines)+1) { 
		recposition = (nrecords-reclines)+1;
	}


	nf=adbf.fldcount();

	fca = new int[nf*2];
	flen = new int[nf*2];
	fname = new String[nf*2];
	valuetype = new String[nf*2];

	for(int cnt=0; cnt<nf*2; cnt++) {
		fca[cnt]=0;
		flen[cnt]=0;
		fname[cnt]="";
		valuetype[cnt]="";
	}

	textabuild = new StringBuffer(1024*reclines);
	int i=0;
	recordlinelen=0;
	String fg = "";
	int j=0;
	int k=0;


  try { 
		 if(recposition>0) adbf.gotoRecord(recposition);


	for(k=1; k <= adbf.fldcount(); k++) {
		   try {
			  f =  adbf.getField(k);
		   } catch(Exception e) { handleError(e.toString()+"<-getfield"); }

		if(f.name().length() > f.length()) fca[k]=f.name().length()+1;
			else fca[k]=f.length()+1;
		flen[k] = f.length();

		fname[k]=f.name();
		valuetype[k] = new Character(f.type()).toString();

		fg=padstring(f.name(), fca[k]);


		recordlinelen+=fca[k];
		textabuild.append(fg);
	}
	textabuild.append("\n");

  } catch(Exception e) { handleError(e.toString()+" goto record:"); }

	for (i = recposition; i < recposition+reclines; i++)
	{
	  try { 
			 if(i>0) adbf.gotoRecord(i);
	  } catch(Exception e) { handleError(e.toString()+" goto record:"); }


		 for (j = 1; j <= adbf.fldcount(); j++)
		 {
			   try {
				  f =  adbf.getField(j);
			   } catch(Exception e) { handleError(e.toString()+"<-getfield"); }

			if(f.get().trim().length()==0) fg=padstring(".", fca[j]);
				else fg=padstring(f.get(), fca[j]);
			if(adbf.deleted()==true) fg=padstring("*", fca[j], "*");
			textabuild.append(fg);

		 }
		textabuild.append("\n");
	}

	String indexstatus="";
	String recordstatus=new Integer(nrecords).toString();
	if(indexexists) indexstatus = indexstatus.concat("    index->"+keyfields);
	String writestatus = "";
	if(readonly) writestatus="  READONLY";
	superframe.setTitle("Records: "+new Integer(recposition).toString()+"-"+new Integer(recposition+reclines-1).toString()+"   file:"+filename+indexstatus+"    Number of Records: "+recordstatus+writestatus);

	
	jp.TextArea.setText(textabuild.toString());


	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }


	while(!jp.TextArea.isValid()) { } 
	jp.TextArea.setCaretPosition(caret);
	return;
}

public String padstring(String st, int len) {
		StringBuffer newstb = new StringBuffer();
		int newlen=0;

		newstb = newstb.append(st);
		if(newstb.length() < len) {
			newlen = len-newstb.length();
			for(int cnt=0; cnt<newlen; cnt++) {
				newstb = newstb.append(" ");
			}
		}
		else newstb.setLength(len);
	
	return newstb.toString();
}

public String padstring(String st, int len, String st2) {
		StringBuffer newstb = new StringBuffer();
		int newlen=0;

		newstb = newstb.append(st);
		if(newstb.length() < len) {
			newlen = len-newstb.length();
			for(int cnt=0; cnt<newlen; cnt++) {
				newstb = newstb.append(st2);
			}
		}
		else newstb.setLength(len);
	
	return newstb.toString();
}

private void goUp() {
	try {
		if(recposition > reclines) { recposition-=reclines; }		
			else { recposition=1; }
		if(filename.length()>0) {
			readRecords(filename, "");
		}
		
	} catch (Exception e) {
		handleError(e.toString());
	}
}

private void goDown() {
	try {

		if(recposition < nrecords-reclines) { recposition+=reclines; }		
			else { recposition=nrecords-reclines; }
		if(filename.length()>0) {
			readRecords(filename, "");
		}

	} catch (Exception e) {
		handleError(e.toString());
	}
}

private void gotoRecord() {
	try {

		String tf = jp.fieldInput.getText();
		if(tf.trim().length()>0) {
			int rec = new Integer(tf).intValue();
			recposition=rec;
			readRecords(filename, "");
		}
		
	} catch (Exception e) {
		handleError(e.toString());
	}
}

private void findRecords() {
	try {

		String tf = jp.fieldInput.getText().trim();
		if(tf.length() > 0) {
			readRecords(filename, tf);
		}
		
	} catch (Exception e) {
		handleError(e.toString());
	}
}

private void gotoTop() {
	if(filename.length()>0) {
		recposition=1;
		readRecords(filename, "");
	}
}

private void gotoBott() {
	if(filename.length()>0) {
		recposition=nrecords-reclines;
		readRecords(filename, "");
	}
}

public void handleError(String error) {
	ErrorDialog ed = new ErrorDialog(superframe, "ERROR:", error, this);
	ed.show();
	return;
}


public void updateDate(String value) {

		if(value.length() > flen[col]) value = value.substring(0,flen[col]);
		writeRecord(filename, row+recposition, col, value);
		readRecords(filename,"");
}


private void addRecords() {
	cancelflag=false;

	AddDialog ad = new AddDialog(superframe, "New Record", this);
	ad.show();
	return;
}

private void indexCreate() {

	String tf = jp.fieldInput.getText().trim();
	if(tf.length() > 0) {
		indexRecords(filename, tf);
		readRecords(filename, "");
	}
}

private void recordPack() {

	if(filename.length()>0) {
		packRecords(filename);
		recposition=1;
		readRecords(filename, "");
	}
}


public void indexRecords(String dbname, String key) {
	
	ConsoleDialog cd = new ConsoleDialog(superframe);
	cd.getConsole().setText("\n\n<Busy Indexing Dbase file>\nPlease Wait...");
	cd.show();

	if(key.length()!=0) {
		try {	
			adbf = new DBF(filename.trim()+".dbf");
			if(!readonly) {	
				adbf.createIndex(filename+".ndx", key, true, false);
			}
			adbf.close();
		} catch(Exception e) { handleError(e.toString()); }
	}
	else { handleError("no key to index on!"); }

	cd.dispose();
}


public void packRecords(String dbname) {
	ConsoleDialog cd = new ConsoleDialog(superframe);
	cd.getConsole().setText("\n\n<Busy Packing Dbase file>\nPlease Wait...");
	cd.show();

	try {
		adbf = new DBF(filename.trim()+".dbf");
		if(indexexists==true) adbf.useIndex(filename+".ndx");
		if(!readonly) adbf.pack();
		adbf.close();
	} catch(Exception e) { handleError(e.toString()); }

	cd.dispose();
}

public void deleteRecords(String dbname, int row) {
	try {
		row--;
		adbf = new DBF(filename.trim()+".dbf");
		if(indexexists==true) adbf.useIndex(filename+".ndx");

		if(row>0) adbf.gotoRecord(row);
		adbf.delete();
		adbf.close();

	} catch(Exception e) { handleError(e.toString()); }

}
public void undeleteRecords(String dbname, int row) {
	try {
		row--;
		adbf = new DBF(filename.trim()+".dbf");
		if(indexexists==true) adbf.useIndex(filename+".ndx");

		if(row>0) adbf.gotoRecord(row);
		adbf.undelete();
		adbf.close();

	} catch(Exception e) { handleError(e.toString()); }

}

public void writeRecord(String dbname, int row, int col, String value) {
	try {
		row--;
		adbf = new DBF(filename.trim()+".dbf");

		if(indexexists==true) adbf.useIndex(filename+".ndx");

		 if(row>0) adbf.gotoRecord(row);
		 adbf.getField(col).put(value);
			if(!readonly) adbf.update();

	} catch(Exception e) { handleError(e.toString()+" opening dbase."); }

	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }

}

public void updateColumn(String dbname, int column) {

	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) { handleError(e.toString()+" opening dbase."); }

	try {
		indexexists=true;
		adbf.useIndex(filename+".ndx");
	} catch(Exception e) {  indexexists=false; } 



	nf=adbf.fldcount();

	fca = new int[nf*2];
	flen = new int[nf*2];
	fname = new String[nf*2];
	valuetype = new String[nf*2];

	for(int cnt=0; cnt<nf*2; cnt++) {
		fca[cnt]=0;
		flen[cnt]=0;
		fname[cnt]="";
		valuetype[cnt]="";
	}

	textabuild = new StringBuffer(1024*reclines);
	int i=0;
	recordlinelen=0;

	int colindex=1;
	
	for (i = recposition; i < recposition+reclines; i++)
	{
		  try { 
			 if(i>0) adbf.gotoRecord(i);
		  } catch(Exception e) { handleError(e.toString()+" goto record:"); }

		String fg = "";
		int j=1;


	   try {
		  f =  adbf.getField(column);

		if(valuetype[colindex].toUpperCase().equals("N") && colvalues[colindex].length()==0) colindex++;
		else if(valuetype[colindex].toUpperCase().equals("D") && colvalues[colindex].length()==0) colindex++;
			else f.put(colvalues[colindex++]);

		if(!readonly) adbf.update();
	   } catch(Exception e) { handleError(e.toString()); }
	}

	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }


	return;
}


public void updateRecord(String dbname, int record) {
	record--;

	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) { handleError(e.toString()+" opening dbase."); }

	try {
		indexexists=true;
		adbf.useIndex(filename+".ndx");
	} catch(Exception e) {  indexexists=false; } 


	   try {
		if(record>0) adbf.gotoRecord(record);	
		 for (int j = 1; j <= adbf.fldcount(); j++) {
				f = adbf.getField(j); 
					
				if(valuetype[j].toUpperCase().equals("N") && addvalues[j].length()==0);
				else if(valuetype[j].toUpperCase().equals("D") && addvalues[j].length()==0);
				else {
					if(addvalues[j].length()>0) f.put(addvalues[j]);
						else f.put(".");
				}
				
		 }
		 if(!readonly) adbf.update();
	   } catch(Exception e) { handleError(e.toString()); }


	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }

	return;
}

public void addRecords(String dbname) {

	try {
		adbf = new DBF(filename.trim()+".dbf");

	} catch(Exception e) { handleError(e.toString() + " open dbase"); }

	try {
		indexexists=true;
		adbf.useIndex(filename+".ndx");
	} catch(Exception e) {  indexexists=false; } 

	

	   try {
		 for (int j = 1; j <= adbf.fldcount(); j++) {
				f = adbf.getField(j); 

				if(valuetype[j].toUpperCase().equals("N") && addvalues[j].length()==0);
				else if(valuetype[j].toUpperCase().equals("D") && addvalues[j].length()==0);
				else {
					if(addvalues[j].length()>0) f.put(addvalues[j]);
						else f.put(".");
				}

		 }
		 if(!readonly) adbf.write();
	   } catch(Exception e) { handleError(e.toString()); }


	try {
		adbf.close();
	} catch(Exception e) { handleError(e.toString() + " close dbase"); }

	reclines = inireclines;

	return;
}



public void getEditValue(String oldval, String newval) {
		EditDialog ed = new EditDialog(superframe, fieldtitle, "", oldval, jp.TextArea, this);
		ed.show();
		return;
}



class AddDialog extends Dialog implements java.awt.event.ActionListener, java.awt.event.KeyListener {

Button cancel = new Button("Cancel");
Button add = new Button("Add");

Panel p0,p1,p2;
Jbrowse thisapplet=null;
CalendarPanel CalPanel=null;
String thedate="";
String mon="";
String day="";
String year="";
public boolean cancelflag=false;

	public AddDialog(Frame parent, String title, Jbrowse applet) {

	super(parent, title, true);

	GridBagConstraints Labelcon = new GridBagConstraints();
	GridBagConstraints Textfieldcon = new GridBagConstraints();

	Labelcon.gridx = 1;
	Labelcon.gridy = 1;
	Labelcon.gridwidth = 1;
	Labelcon.gridheight = 1;
	Labelcon.anchor = java.awt.GridBagConstraints.EAST;
	Labelcon.fill = java.awt.GridBagConstraints.NONE;
	Labelcon.weightx = 100.0;
	Labelcon.weighty = 100.0;
	Labelcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Labelcon.ipadx = 5; 
	Labelcon.ipady = 0; 

	Textfieldcon.gridx = 2; 
	Textfieldcon.gridy = 1;
	Textfieldcon.gridwidth = 1; 
	Textfieldcon.gridheight = 1;
	Textfieldcon.anchor = java.awt.GridBagConstraints.WEST;
	Textfieldcon.fill = java.awt.GridBagConstraints.NONE;
	Textfieldcon.weightx = 100.0;
	Textfieldcon.weighty = 100.0;
	Textfieldcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Textfieldcon.ipadx = 5; 
	Textfieldcon.ipady = 0; 

		Toolkit tk = parent.getToolkit(); 
		Rectangle r = parent.getBounds();
	

		int adjwidth = new Double(r.width*.98).intValue();
		int adjheight = new Double(r.height*.98).intValue();

		this.setSize(adjwidth, adjheight);
		this.setBounds(new Rectangle(((r.width-adjwidth)/2)+r.x, ((r.height-adjheight)/2)+r.y, adjwidth, adjheight));

		thisapplet = applet;
		cancelflag=false;

		this.setLayout(new BorderLayout());

		ScrollPane sp = new ScrollPane();
		add(sp, "Center");

		thisapplet.addvalues = new String[thisapplet.nf+1];


		p0 = new Panel();

		p1 = new Panel();
		p1.setLayout(new GridBagLayout());
		
		int compindex=0;
		boolean toowide=false;
		String showtype="";

		for(int cnt=1; cnt<=thisapplet.nf; cnt++) {
			if(thisapplet.showtype) showtype = thisapplet.valuetype[cnt];
			Label l1 = new Label(thisapplet.fname[cnt]+"("+new Integer(thisapplet.flen[cnt]).toString()+")"+"    "+showtype);
			TextField tf1 = new TextField(thisapplet.flen[cnt]);
			if(thisapplet.flen[cnt] > thisapplet.maxfieldwidthcol) toowide=true;
				else toowide=false; 

			l1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));
			tf1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));

			tf1.setEditable(true);


			if(toowide==true) {
				if(Labelcon.gridx==3) { 
					Labelcon.gridx=1;
					Labelcon.gridy++;
					Textfieldcon.gridx=2;
					Textfieldcon.gridy++;

					Labelcon.gridwidth=1;
					Textfieldcon.gridwidth=3;
				}
			} 
			if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {

				CalPanel = new CalendarPanel("Date");
				CalPanel.addActionListener(this);
				Date editdate = new Date(); 
				CalPanel.setDate(editdate);

				mon = new Integer(editdate.getMonth()+1).toString();
				day = new Integer(editdate.getDate()).toString();
				year = new Integer(editdate.getYear()+1900).toString();
				if(mon.length()==1) mon = "0".concat(mon); 
				if(day.length()==1) day = "0".concat(day); 
				thedate = year+mon+day;

				CalPanel.setAttachToTop(false);
				CalPanel.setRefreshParent(true, (java.awt.Container) this);

				p1.add(CalPanel);
				((java.awt.GridBagLayout) p1.getLayout()).setConstraints(CalPanel, Textfieldcon);
			}


			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(l1, Labelcon);
			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(tf1, Textfieldcon);

			p1.add(l1,compindex++);
			if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {
				p1.add(CalPanel,compindex++);
			}
			else { 
				p1.add(tf1,compindex++); 
			}
			

			if(toowide==false) {
				if(Labelcon.gridx==1) Labelcon.gridx=3;
					else { Labelcon.gridx=1; Labelcon.gridy++; }
				if(Textfieldcon.gridx==2) Textfieldcon.gridx=4;
					else { Textfieldcon.gridy++; Textfieldcon.gridx=2; }
				Labelcon.gridwidth=1;
				Textfieldcon.gridwidth=1;
			}
			else {
				Labelcon.gridx=1; Labelcon.gridy++; Labelcon.gridwidth=1; 
				Textfieldcon.gridy++; Textfieldcon.gridx=2; Textfieldcon.gridwidth=3; 
			}
		}
		p0.add(p1);

		p2 = new Panel();
		p2.add(cancel);
		p2.add(add);
		p0.add(p2);

		sp.add(p0, "Center");

		initlisteners();
	}
	public void initlisteners() {
		cancel.addActionListener(this);
		add.addActionListener(this);
	}

	public void keyTyped(java.awt.event.KeyEvent e) {
		System.out.println(e.toString());
	}
	public void keyReleased(java.awt.event.KeyEvent e) {
		System.out.println(e.toString());
	}
	public void keyPressed(java.awt.event.KeyEvent e) {
		System.out.println(e.toString());
	}

	public void actionPerformed(java.awt.event.ActionEvent e) {

		if(e.getSource()==CalPanel) {
			thedate = CalPanel.getDateString(); 
			thisapplet.newval="";

			Date editdate = CalPanel.getDate();
			mon = new Integer(editdate.getMonth()+1).toString();
			day = new Integer(editdate.getDate()).toString();
			year = new Integer(editdate.getYear()+1900).toString();
			if(mon.length()==1) mon = "0".concat(mon); 
			if(day.length()==1) day = "0".concat(day); 
			thedate = year+mon+day;

			CalPanel.dropit(false);
		}
		
		if(e.getSource() == cancel) {
			cancelflag=true;
			disposeit();
		}
		
		if(e.getSource() == add) {
			int compindex=0;
			for(int cnt=1; cnt<=thisapplet.nf; cnt++) {
				compindex++;

				if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {
					thisapplet.addvalues[cnt] = thedate; 
					compindex++;
				}
				else {
					TextField tf = (TextField) p1.getComponent(compindex++);
					if(tf.getText().length() > thisapplet.flen[cnt]) thisapplet.addvalues[cnt] = tf.getText().substring(0,thisapplet.flen[cnt]);
						else thisapplet.addvalues[cnt] = tf.getText();
				}
			}
			disposeit();
		}

	}

	public void disposeit() {

		if(!cancelflag) {
			thisapplet.addRecords(thisapplet.filename);
			thisapplet.recposition++;
			thisapplet.readRecords(thisapplet.filename, "");
		}
		dispose();
	}


}

class EditRowDialog extends Dialog implements java.awt.event.ActionListener, java.awt.event.KeyListener {

Button cancel = new Button("Cancel");
Button update = new Button("Update");


CalendarPanel CalPanel=null;
String thedate="";
String mon="";
String day="";
String year="";
public boolean cancelflag=false;

Panel p0,p1,p2;
Jbrowse thisapplet=null;


	public EditRowDialog(Frame parent, String title, Jbrowse applet) {
		super(parent, title, true);


	GridBagConstraints Labelcon = new GridBagConstraints();
	GridBagConstraints Textfieldcon = new GridBagConstraints();

	Labelcon.gridx = 1;
	Labelcon.gridy = 1;
	Labelcon.gridwidth = 1;
	Labelcon.gridheight = 1;
	Labelcon.anchor = java.awt.GridBagConstraints.EAST;
	Labelcon.fill = java.awt.GridBagConstraints.NONE;
	Labelcon.weightx = 100.0;
	Labelcon.weighty = 100.0;
	Labelcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Labelcon.ipadx = 5; 
	Labelcon.ipady = 0; 

	Textfieldcon.gridx = 2; 
	Textfieldcon.gridy = 1;
	Textfieldcon.gridwidth = 1; 
	Textfieldcon.gridheight = 1;
	Textfieldcon.anchor = java.awt.GridBagConstraints.WEST;
	Textfieldcon.fill = java.awt.GridBagConstraints.NONE;
	Textfieldcon.weightx = 100.0;
	Textfieldcon.weighty = 100.0;
	Textfieldcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Textfieldcon.ipadx = 5; 
	Textfieldcon.ipady = 0; 

		Toolkit tk = parent.getToolkit(); 
		Rectangle r = parent.getBounds();
	

		int adjwidth = new Double(r.width*.98).intValue();
		int adjheight = new Double(r.height*.98).intValue();

		this.setSize(adjwidth, adjheight);
		this.setBounds(new Rectangle(((r.width-adjwidth)/2)+r.x, ((r.height-adjheight)/2)+r.y, adjwidth, adjheight));

		thisapplet = applet;
		cancelflag=false;
		

		this.setLayout(new BorderLayout());

		ScrollPane sp = new ScrollPane();
		add(sp, "Center");

		p0 = new Panel();

		p1 = new Panel();
		p1.setLayout(new GridBagLayout());
		boolean toowide=false;
		String showtype="";
		
		int compindex=0;
		for(int cnt=1; cnt<=thisapplet.nf; cnt++) {
			if(thisapplet.showtype) showtype = thisapplet.valuetype[cnt];
			Label l1 = new Label(thisapplet.fname[cnt]+"("+new Integer(thisapplet.flen[cnt]).toString()+")"+"    "+showtype);
			TextField tf1 = new TextField(thisapplet.addvalues[cnt]);
			tf1.setColumns(thisapplet.flen[cnt]);
			tf1.setEditable(true);

			if(thisapplet.flen[cnt] > thisapplet.maxfieldwidthcol) toowide=true;
				else toowide=false; 

			l1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));
			tf1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));

			tf1.setEditable(true);
			if(toowide==true) {
				if(Labelcon.gridx==3) { 
					Labelcon.gridx=1;
					Labelcon.gridy++;
					Textfieldcon.gridx=2;
					Textfieldcon.gridy++;

					Labelcon.gridwidth=1;
					Textfieldcon.gridwidth=3;
				}
			} 

			if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {
				CalPanel = new CalendarPanel("Date");
				CalPanel.addActionListener(this);
				CalPanel.setAttachToTop(false);
				CalPanel.setRefreshParent(true, (java.awt.Container) this);

				String year = thisapplet.addvalues[cnt].substring(0,4);
				String mon = thisapplet.addvalues[cnt].substring(4,6);
				String day = thisapplet.addvalues[cnt].substring(6,8);

				CalPanel.setDateString(mon+"/"+day+"/"+year);
				thedate = CalPanel.getDateString(); 

				((java.awt.GridBagLayout) p1.getLayout()).setConstraints(CalPanel, Textfieldcon);
			}


			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(l1, Labelcon);
			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(tf1, Textfieldcon);


			p1.add(l1,compindex++);
			if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {
				p1.add(CalPanel,compindex++);
			}
			else { 
				p1.add(tf1,compindex++); 
			}

			if(toowide==false) {
				if(Labelcon.gridx==1) Labelcon.gridx=3;
					else { Labelcon.gridx=1; Labelcon.gridy++; }
				if(Textfieldcon.gridx==2) Textfieldcon.gridx=4;
					else { Textfieldcon.gridy++; Textfieldcon.gridx=2; }
				Labelcon.gridwidth=1;
				Textfieldcon.gridwidth=1;
			}
			else {
				Labelcon.gridx=1; Labelcon.gridy++; Labelcon.gridwidth=1; 
				Textfieldcon.gridy++; Textfieldcon.gridx=2; Textfieldcon.gridwidth=3; 
			}
		}
		p0.add(p1);

		p2 = new Panel();
		p2.add(cancel);
		p2.add(update);
		p0.add(p2);

		sp.add(p0, "Center");
		initListeners();

	}

	public void initListeners() {
		cancel.addActionListener(this);
		update.addActionListener(this);
	}

	public void keyTyped(java.awt.event.KeyEvent e) {
	}
	public void keyReleased(java.awt.event.KeyEvent e) {
	}
	public void keyPressed(java.awt.event.KeyEvent e) {
	}

	public void actionPerformed(java.awt.event.ActionEvent e) {

		if(e.getSource()==CalPanel) {
			thedate = CalPanel.getDateString(); 
			CalPanel.dropit(false);
			CalPanel.setAttachToTop(false);
			CalPanel.setRefreshParent(true, (java.awt.Container) this);
		}
		
		if(e.getSource() == cancel) {
			thisapplet.cancelflag=true;
			disposeit();
		}
		
		if(e.getSource() == update) {
			thisapplet.cancelflag=false;
			int compindex=0;
			for(int cnt=1; cnt<=thisapplet.nf; cnt++) {
				compindex++;
				if(thisapplet.valuetype[cnt].trim().toUpperCase().equals("D") && thisapplet.usedatepicker==true) {
					thedate = CalPanel.getDateString(); 
					String mon = thedate.substring(0,2);
					String day = thedate.substring(3,5);
					String year = thedate.substring(6,10);
					thedate = year+mon+day;	
					thisapplet.addvalues[cnt] = thedate; 
					compindex++;
				}
				else {
					TextField tf = (TextField) p1.getComponent(compindex++);
					if(tf.getText().length() > thisapplet.flen[cnt]) thisapplet.addvalues[cnt] = tf.getText().substring(0,thisapplet.flen[cnt]);
						else thisapplet.addvalues[cnt] = tf.getText();
					if(thisapplet.addvalues[cnt].equals(".")) thisapplet.addvalues[cnt]="";
				}
			}
			disposeit();
		}

	}

	public void disposeit() {

		if(!thisapplet.cancelflag) { 
			thisapplet.updateRecord(thisapplet.filename, thisapplet.row+thisapplet.recposition);
			thisapplet.readRecords(thisapplet.filename, "");
		}
		dispose();
	}

}




class EditColDialog extends Dialog implements java.awt.event.ActionListener, java.awt.event.KeyListener {

Button cancel = new Button("Cancel");
Button update = new Button("Update");
Button fill = new Button("Fill");
TextField tf = new TextField(6);

Panel p0,p1,p2;
Jbrowse thisapplet=null;

	public EditColDialog(Frame parent, String title, Jbrowse applet) {
		super(parent, title, true);

	GridBagConstraints Labelcon = new GridBagConstraints();
	GridBagConstraints Textfieldcon = new GridBagConstraints();

	Labelcon.gridx = 1;
	Labelcon.gridy = 1;
	Labelcon.gridwidth = 1;
	Labelcon.gridheight = 1;
	Labelcon.anchor = java.awt.GridBagConstraints.EAST;
	Labelcon.fill = java.awt.GridBagConstraints.NONE;
	Labelcon.weightx = 100.0;
	Labelcon.weighty = 100.0;
	Labelcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Labelcon.ipadx = 5; 
	Labelcon.ipady = 0; 

	Textfieldcon.gridx = 2; 
	Textfieldcon.gridy = 1;
	Textfieldcon.gridwidth = 1; 
	Textfieldcon.gridheight = 1;
	Textfieldcon.anchor = java.awt.GridBagConstraints.WEST;
	Textfieldcon.fill = java.awt.GridBagConstraints.NONE;
	Textfieldcon.weightx = 100.0;
	Textfieldcon.weighty = 100.0;
	Textfieldcon.insets = new java.awt.Insets(0, 0, 0, 0);
	Textfieldcon.ipadx = 5; 
	Textfieldcon.ipady = 0; 

		Toolkit tk = parent.getToolkit(); 
		Rectangle r = parent.getBounds();
	
		Dimension ssize = tk.getScreenSize();

		int adjwidth = new Double(r.width*.90).intValue();
		int adjheight = new Double(ssize.height*.90).intValue();
		this.setSize(adjwidth, adjheight);
		this.setBounds(new Rectangle(((r.width-adjwidth)/2)+r.x, ((r.height-adjheight)/2)+r.y, adjwidth, adjheight));

		thisapplet = applet;
		thisapplet.cancelflag=false;

		this.setLayout(new BorderLayout());

		ScrollPane sp = new ScrollPane();
		add(sp, "Center");

		p0 = new Panel();

		boolean toowide=false;

		String showtype="";
		p1 = new Panel();
		p1.setLayout(new GridBagLayout());
		
		int compindex=0;
		for(int cnt=1; cnt<=thisapplet.reclines; cnt++) {
			if(thisapplet.showtype) showtype = thisapplet.valuetype[cnt];
			Label l1 = new Label(thisapplet.fname[1]+"("+new Integer(thisapplet.flen[1]).toString()+")"+"    "+showtype);
			TextField tf1 = new TextField(thisapplet.colvalues[cnt]);
			tf1.setColumns(thisapplet.flen[1]);

			if(thisapplet.flen[1] > thisapplet.maxfieldwidthcol) toowide=true;
				else toowide=false; 

			l1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));
			tf1.setFont(new java.awt.Font("Monospaced", 0, thisapplet.entryfontsize));

			tf1.setEditable(true);
			p1.add(l1,compindex++);
			p1.add(tf1,compindex++);
			if(toowide==true) {
				if(Labelcon.gridx==3) { 
					Labelcon.gridx=1;
					Labelcon.gridy++;
					Textfieldcon.gridx=2;
					Textfieldcon.gridy++;

					Labelcon.gridwidth=1;
					Textfieldcon.gridwidth=3;
				}
			} 

			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(l1, Labelcon);
			((java.awt.GridBagLayout) p1.getLayout()).setConstraints(tf1, Textfieldcon);

			if(toowide==false) {
				if(Labelcon.gridx==1) Labelcon.gridx=3;
					else { Labelcon.gridx=1; Labelcon.gridy++; }
				if(Textfieldcon.gridx==2) Textfieldcon.gridx=4;
					else { Textfieldcon.gridy++; Textfieldcon.gridx=2; }
				Labelcon.gridwidth=1;
				Textfieldcon.gridwidth=1;
			}
			else {
				Labelcon.gridx=1; Labelcon.gridy++; Labelcon.gridwidth=1; 
				Textfieldcon.gridy++; Textfieldcon.gridx=2; Textfieldcon.gridwidth=3; 
			}


		}
		p0.add(p1);

		p2 = new Panel();
		p2.add(cancel);
		p2.add(update);
		p2.add(fill);
		p2.add(tf);
		p0.add(p2);

		sp.add(p0, "Center");
		initlisteners();

	}
	public void initlisteners() {
		cancel.addActionListener(this);
		update.addActionListener(this);
		fill.addActionListener(this);
	}

	public void keyTyped(java.awt.event.KeyEvent e) {
	}
	public void keyReleased(java.awt.event.KeyEvent e) {
	}
	public void keyPressed(java.awt.event.KeyEvent e) {
	}

	public void actionPerformed(java.awt.event.ActionEvent e) {
		
		if(e.getSource() == cancel) {
			thisapplet.cancelflag=true;
			dispose();
		}
		if(e.getSource() == fill) {
			if(tf.getText().length()==0) return; 
			int compindex=0;
			for(int cnt=1; cnt<=thisapplet.reclines; cnt++) {
				if(tf.getText().length() > thisapplet.flen[1]) thisapplet.colvalues[cnt] = tf.getText().substring(0,thisapplet.flen[1]);
					else thisapplet.colvalues[cnt] = tf.getText();
				if(thisapplet.colvalues[cnt].equals(".")) thisapplet.colvalues[cnt]="";
			}
			dispose();
		}
		
		if(e.getSource() == update) {
			int compindex=0;
			for(int cnt=1; cnt<=thisapplet.reclines; cnt++) {
				compindex++;
				TextField tf = (TextField) p1.getComponent(compindex++);		
				if(tf.getText().length() > thisapplet.flen[1]) thisapplet.colvalues[cnt] = tf.getText().substring(0,thisapplet.flen[1]);
					else thisapplet.colvalues[cnt] = tf.getText();
				if(thisapplet.colvalues[cnt].equals(".")) thisapplet.colvalues[cnt]="";
			}
			dispose();
		}

	}


}


class ErrorDialog extends Dialog implements java.awt.event.ActionListener {

Button ok = new Button("Ok");
Label  error=null;
Panel p1,p2;

Jbrowse thisapplet=null;

	public ErrorDialog(Frame parent, String title, String error, Jbrowse applet) {

		super(parent, title, true);
		Toolkit tk = parent.getToolkit(); 
		Rectangle r = parent.getBounds();

		int adjwidth = new Double(r.width*.90).intValue();
		int adjheight = new Double(r.height*.25).intValue();

		this.setSize(adjwidth, adjheight);
		this.setBounds(new Rectangle(((r.width-adjwidth)/2)+r.x, ((r.height-adjheight)/2)+r.y, adjwidth, adjheight));

		thisapplet = applet;

		p1 = new Panel();
		p1.add(new Label(error));
		add(p1, "North");

		p2 = new Panel();
		p2.add(ok);
		add(p2, "South");
		ok.addActionListener(this);

	}


	public void actionPerformed(java.awt.event.ActionEvent e) {
		
		if(e.getSource() == ok) {
			dispose();
		}
	}


}


}//Jbrowse class
